//
//	HSP3 code manager
//	(ԌWJуp[^[擾)
//	onion software/onitama 2004/6
//
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include <iostream>
#include <sstream>
#include <vector>
#include <stack>
#include <map>
#include <set>
#include <windows.h>
#include <mmsystem.h>
#include "hspwnd.h"
#include "supio.h"
#include "dpmread.h"
#include "stack.h"
#include "strbuf.h"
#include "hsp3jit.h"
#include "hsp3code.h"
#include "hsp3debug.h"
#include "hsp3config.h"
#include "hsp3int.h"


#include "llvm/Module.h"
#include "llvm/DerivedTypes.h"
#include "llvm/Constants.h"
#include "llvm/Instructions.h"
#include "llvm/ModuleProvider.h"
#include "llvm/PassManager.h"
#include "llvm/Analysis/Verifier.h"
#include "llvm/Target/TargetData.h"
#include "llvm/Transforms/Scalar.h"
#include "llvm/ExecutionEngine/JIT.h"
#include "llvm/ExecutionEngine/Interpreter.h"
#include "llvm/ExecutionEngine/GenericValue.h"
#include "llvm/Support/IRBuilder.h"

using namespace llvm;


#define strp(dsptr) &s_hspctx->mem_mds[dsptr]

/*------------------------------------------------------------*/
/*
		system data
*/
/*------------------------------------------------------------*/

static HSP3TYPEINFO *s_hsp3tinfo;	// HSP3 type info structure (strbuf)
static int s_tinfo_cur;			// Current type info ID
#define GetTypeInfoPtr( type ) (&s_hsp3tinfo[type])

static HSPCTX *s_hspctx;			// Current Context
static unsigned short *s_mcs;		// Current PC ptr
static unsigned short *s_mcsbak;
static int s_val, s_type, s_exflg;
static int s_hspevent_opt;		// Event enable flag
static MPModVarData s_modvar_init;
static int s_sptr_res;
static int s_arrayobj_flag;

static HSPEXINFO s_mem_exinfo;	// HSPEXINFO{

#ifdef HSPDEBUG
static HSP3DEBUG s_dbginfo;
static int s_dbgmode;
#endif

static PVal *s_plugin_pval;								// vOCɓnϐ|C^̎
static PVal *s_mpval;									// jit_getŎgpꂽe|ϐ
static PVal s_prmvar;								// p[^[e|ϐ̎

static	unsigned char *s_mem_di_val;				// Debug VALS info ptr
static	int s_srcname;
static	int s_funcres;							// ֐̖߂l^
//static HspStack stack;
//static Hsp3Asm *jitasm;

extern "C" {
	void hspExtMes(int n);
}

void* hspLazyFunctionCreator(const std::string & name) {
	if (name == "hspExtMes") {
		return hspExtMes;
	}
	return NULL;
}

class Code {
public:
	int offset;
	unsigned short type;
	unsigned short exflg;
	int val;

	bool newline() {
		return static_cast<bool>(exflg & EXFLG_1);
	}

	bool comma() {
		return static_cast<bool>(exflg & EXFLG_2);
	}

	int read(unsigned short* mcs, int ofs) {
		//		Get 1 command block
		//		(ver3.0ȍ~p)
		//
		register unsigned short a;
		offset = ofs;
		a = mcs[ofs++];
		exflg = a & (EXFLG_1|EXFLG_2);
		type = a & CSTYPE;

		if ( a&0x8000 ) {
			//	 32bit val code
			//
			val = (int)*((int *)(mcs + ofs));
			ofs += 2;
			//		printf( "%08x | type[%d] val[%d] ex[%d]\n",(int)(s_mcs-s_hspctx->mem_mcs), type,val,s_exflg );
			//jit_dump_cur();
			return ofs;
		}
		// 16bit val code
		val = (int)mcs[ofs++];

		//	printf( "%08x : type[%d] val[%d] ex[%d]\n",(int)(s_mcs-s_hspctx->mem_mcs), type,val,s_exflg );
		//jit_dump_cur();
		return ofs;
	}

	void dump() {
		printf( "%08x : type[%d] val[%d] ex[%04x]\n", offset + 2, type, val, exflg);
	}
};
typedef std::vector<Code> Codes;
typedef Codes::iterator CodeIter;


class Parser {
	StructType *typePVal;
	PointerType *typePPVal;
	GlobalVariable *varMemVar;
public:
	explicit Parser(HSPCTX* _ctx, Module *m) : ctx(_ctx), module(m), lastLabel(0) {
		int ofs = 0;
		unsigned short* mcs = ctx->mem_mcs;
		int size = ctx->hsphed->max_cs;

		printf("parse cs_size:%d\n", ctx->hsphed->max_cs);
		printf("parse pt_cs:%d\n", ctx->hsphed->pt_cs);
		codes.reserve(size);
		while (ofs < size / 2) {
			Code c;
			ofs = c.read(mcs, ofs);
			codes.push_back(c);
			if (c.type == TYPE_CMPCMD) {
				Code c;
				c.type = -1;
				c.val = mcs[ofs++] * 2;
				c.offset = 0;
				c.exflg = 0;
				codes.push_back(c);
			}
		}
		printf("code.size() = %d\n", codes.size());

		//Initialize llvm type
		std::vector<const Type*> elements;
		elements.push_back(Type::Int16Ty);//flag
		elements.push_back(Type::Int16Ty);//mode
		elements.push_back(ArrayType::get(Type::Int32Ty, 5));//len[5]
		elements.push_back(Type::Int32Ty);//size
		elements.push_back(PointerType::getUnqual(Type::Int8Ty));//pt
		typePVal = StructType::get(elements, true);

		typePPVal = PointerType::getUnqual(typePVal);

		varMemVar = new GlobalVariable(
			typePPVal,
			true,
			GlobalVariable::ExternalLinkage,
			ConstantExpr::getIntToPtr(ConstantInt::get(Type::Int32Ty, (int)ctx->mem_var), typePPVal),
			"mem_var",
			module
			);

		progCmdStop = cast<Function>(module->
			getOrInsertFunction("stop", Type::VoidTy, NULL));


		progExtCmdMes = cast<Function>(module->
			getOrInsertFunction("hspExtMes", Type::VoidTy, Type::Int32Ty, NULL));
		progExtCmdMes->setLinkage(GlobalValue::LinkageTypes::ExternalLinkage);
		//progExtCmdMes->setCallingConv(CallingConv::C);
	}

	std::vector<BasicBlock*> blocks;
	std::map<int, BasicBlock*> labels;
	std::map<int, BasicBlock*> lines;
	std::set<BasicBlock*> unused;
	std::vector<std::string> buffer;

	bool needBranch;
	BasicBlock* nextBlock;
	Function *func;

	BasicBlock* getLineBlock(int offset) {
		if (lines.find(offset) == lines.end()) {
			char lbl[32];
			sprintf(lbl, "code_%d", offset);
			buffer.push_back(lbl);
			BasicBlock *bb =  BasicBlock::Create(*buffer.rbegin(), func);
			lines[offset] = bb;
		}
		return lines[offset];
	}
	Function* parse() {
		try {
			func = cast<Function>(module->getOrInsertFunction("hspMain", Type::VoidTy, (Type *)0));

			builder = new IRBuilder(BasicBlock::Create("EntryBlock", func));
			blocks.push_back(builder->GetInsertBlock());
/*
			parseLiterals();
			prologue();
*/
			nextBlock = NULL;
/*
			for (int j = 0; j < codes.size(); j++) {
				const Code& code = codes[j];
				if (code.type == (unsigned short)-1)
					continue;
				char lbl[32];
				sprintf(lbl, "code_%d_%d", j, code.offset);
				buffer.push_back(lbl);
				BasicBlock *bb =  BasicBlock::Create(*buffer.rbegin(), func);
				lines[code.offset] = bb;
				unused.insert(bb);
			}
*/

			for (int i = 0; i < ctx->hsphed->max_ot; i++) {
				int lbl = ctx->mem_ot[i];
				if (lbl >= 0 && lbl <= codes.rbegin()->offset)
					labels[i] = getLineBlock(lbl);
			}

			for (codeIndex = 0; codeIndex < codes.size();) {
				Code& code = codes[codeIndex];
				printf("[statement] %d %d\n", codeIndex, code.offset);

				BasicBlock *bb = getLineBlock(code.offset);
				unused.erase(bb);
				if (nextBlock != NULL) {
					if (needBranch)
						builder->CreateBr(nextBlock);
					builder->SetInsertPoint(nextBlock);
					builder->CreateBr(bb);
				} else {
					if (needBranch)
						builder->CreateBr(bb);
				}
				builder->SetInsertPoint(bb);
				blocks.push_back(bb);
				//lines[code.offset] = bb;
#if 0
				for (int i = 0; i < ctx->hsphed->max_ot; i++) {
					if (code.offset == ctx->mem_ot[i]) {
						//printf("declare label %d:\n", i);
/*
*/
						labels[i] = bb;
						break;
					}
				}
#endif
				needBranch = true;
				nextBlock = NULL;
				parseStatement();
			}

			if (needBranch)
				builder->CreateRetVoid();

			for (std::set<BasicBlock*>::iterator it = unused.begin(); it != unused.end(); ++it) {
				builder->SetInsertPoint(*it);
				builder->CreateAdd(ConstantInt::get(Type::Int32Ty, 0xdead), ConstantInt::get(Type::Int32Ty, 0xbeef));
				builder->CreateRetVoid();
			}

			return func;
/*
			epilogue();
*/
		} catch (...) {
			printf("parse error\n");
			return NULL;
		}
	}

	void parseStatement() {
		Code& code = codes[codeIndex];
		switch (code.type) {
        case TYPE_VAR:
		case TYPE_STRUCT:
			printf("parseAssignment(mv)\n");
			parseAssignment();
			break;
		case TYPE_INTCMD:
		case TYPE_EXTCMD:
			printf("parseCommand(mv)\n");
			parseCommand();
			break;
		case TYPE_CMPCMD:
			printf("parseCompareCommand(mv)\n");
			parseCompareCommand();
			break;
		case TYPE_MODCMD:
			printf("parseModuleCommand(mv, false)\n");
			code.dump();
			throw 0;
			break;
		case TYPE_PROGCMD:
			printf("parseProgcmd\n");
			parseProgcmd();
			break;
		case TYPE_DLLFUNC:
			printf("parseDllCommand(mv)\n");
			throw 0;
			break;
		case TYPE_DLLCTRL:
			printf("parseCommand(mv)\n");
			throw 0;
			break;
		default:
			printf("error statement %d\n", code.type);
			code.dump();
			throw 0;
			//throw new RuntimeException("߃R[h " + ax.codes[codeIndex].type + " ͉
			break;
		}
	}

	void parseAssignment() {
/*
		int index = codeIndex;

		if (codes[codeIndex].type == TYPE_VAR) {
			parseVar();
		} else {
			parseParam();
		}

		codeIndex = index;
*/
		if (codes[codeIndex].type == TYPE_VAR) {
			parseVar();
		} else {
			parseParam();
		}

		Value* lhs = varStack.top();
		varStack.pop();
		//Value* pPvalPt = builder->CreateGEP(lhs, ConstantInt::get(APInt(32, 3)));
		Value* pPvalPt = pvalToPInt(lhs);

		Code& code = codes[codeIndex++];
		if (codeIndex < codes.size() && !codes[codeIndex].newline()) {
			int name = code.val;
			do {
				Value* rhs = parseExpression();
				if (rhs->getType() == typePPVal) {
					rhs = pvalToInt(rhs);
				}
/*
				if (lhs->getType() != typePPVal) {
					printf("lhs isn't variable\n");
					std::cout << *lhs->getType() << std::endl;
					std::cout << *typePPVal << std::endl;
					throw 0;
				}
*/
				Value* ptr = pPvalPt;
				Value* val = builder->CreateLoad(ptr);
				Value * res = NULL;
				switch (name) {
	             case CALCCODE_ADD:
					 res = builder->CreateAdd(val, rhs);
					 break;
				 case CALCCODE_SUB:
					 res = builder->CreateSub(val, rhs);
					 break;
				 case CALCCODE_MUL:
					 res = builder->CreateMul(val, rhs);
					 //proc->MulI( pval, ptr );
					 break;
				 case CALCCODE_DIV:
					 res = builder->CreateSDiv(val, rhs);
					 break;
				 case CALCCODE_MOD:						// '%'
					 res = builder->CreateSRem(val, rhs);
					 break;

				 case CALCCODE_AND:
					 res = builder->CreateAnd(val, rhs);
					 break;
				 case CALCCODE_OR:
					 res = builder->CreateOr(val, rhs);
					 break;
				 case CALCCODE_XOR:
					 res = builder->CreateXor(val, rhs);
					 break;

				 case CALCCODE_EQ:
					 {
						 Value* ptr = pPvalPt;
						 Value* val = builder->CreateLoad(ptr);
						 builder->CreateStore(rhs, ptr);
						 continue;
					 }
					 break;
				 case CALCCODE_NE:
					 res = builder->CreateICmpNE(val, rhs);
					 //proc->NeI( pval, ptr );
					 break;
				 case CALCCODE_GT:
					 res = builder->CreateICmpSGT(val, rhs);
					 //proc->GtI( pval, ptr );
					 break;
				 case CALCCODE_LT:
					 res = builder->CreateICmpSLT(val, rhs);
					 break;
				 case CALCCODE_GTEQ:						// '>='
					 res = builder->CreateICmpSGE(val, rhs);
					 break;
				 case CALCCODE_LTEQ:						// '<='
					 res = builder->CreateICmpSLE(val, rhs);
					 break;

				 case CALCCODE_RR:						// '>>'
					 res = builder->CreateLShr(val, rhs);
					 break;
				 case CALCCODE_LR:						// '<<'
					 res = builder->CreateShl(val, rhs);
					 break;
				 default:
					 printf("unknown operator %d\n", name);
				}
				printf("assign_%d\n", name);
				if (res != NULL) {
					Value* ptr = pPvalPt;//TODO z̃T|[g
					builder->CreateStore(res, ptr);
				} else {
					throw 0;
				}
			} while (codeIndex < codes.size() && !codes[codeIndex].newline());
		} else {
			int name = codes[codeIndex].val;
				printf("assign1_%d\n", name);
		}
	}

	Function* compileExpression() {
		Function *func =
			cast<Function>(module->getOrInsertFunction("hspFunc_" + codeIndex, Type::Int32Ty, (Type *)0));

		builder = new IRBuilder(BasicBlock::Create("EntryBlock", func));

		Value* ret = parseExpression();

		// Create: ret int 1
		builder->CreateRet(ret);

		return func;
	}

	Value* parseExpression() {
		//size_t index = codeIndex;

		do {
			parseToken();
		} while (codeIndex < codes.size()
				&& !(codes[codeIndex].type == TYPE_MARK && (codes[codeIndex].val == ')' || codes[codeIndex].val == '?'))
				&& !(codes[codeIndex].newline() || codes[codeIndex].comma()));
		Value* top = varStack.top();
		varStack.pop();
		return top;
	}

	void parseProgcmd() {
		Code& code = codes[codeIndex];
		switch( code.val ) // TuR}hƂ̕
		{
		case 0x00:								// goto
			printf("\tgoto\n");
			parseGoto();
			//		system_data.mcs = code_getlb();
			//		jit_next();
			break;

		case 0x01:								// gosub
			{
				printf("\tgosub\n");
				unsigned short *sbr;
				//		sbr = code_getlb();
				//		return cmdfunc_gosub( sbr );
			}
			break;
		case 0x02:								// return
			printf("\treturn\n");
			//		if ( system_data.exflg == 0 ) cmdfunc_return_setval();
			//		system_data.hspctx->runmode = RUNMODE_RETURN;
			//		return RUNMODE_RETURN;
			break;
		case 0x03:								// break
			printf("\tbreak;\n");
			//		if (system_data.hspctx->looplev==0) throw HSPERR_LOOP_WITHOUT_REPEAT;
			//		system_data.hspctx->looplev--;
			//		system_data.mcs = code_getlb();
			//		jit_next();
			break;

		case 0x04:								// repeat
			printf("\trepeat\n");
			{
				throw 0;
				//parseRepeat();
				/*		LOOPDAT *lop;
				unsigned short *label;
				if (system_data.hspctx->looplev>=(HSP3_REPEAT_MAX-1)) throw HSPERR_TOO_MANY_NEST;
				label = code_getlb();
				jit_next();
				p1 = code_getdi( ETRLOOP );
				p2 = code_getdi( 0 );
				if ( p1==0 ) {				// 0͑break
				system_data.mcs=label;
				jit_next();
				break;
				}
				if ( p1<0 ) p1=ETRLOOP; else p1+=p2;
				system_data.hspctx->looplev++;
				lop=GETLOP(system_data.hspctx->looplev);
				lop->cnt = p2;
				lop->time = p1;
				lop->pt = system_data.mcsbak;*/
				break;
			}

		case 0x05:								// loop
			printf("\tloop\n");
			{
				throw 0;
				//parseLoop();
				/*
				LOOPDAT *lop;
				if (system_data.hspctx->looplev==0) throw HSPERR_LOOP_WITHOUT_REPEAT;
				lop=GETLOP(system_data.hspctx->looplev);
				lop->cnt++;
				if ( lop->time != ETRLOOP ) {		// not eternal loop
				if ( lop->cnt >= lop->time ) {
				system_data.hspctx->looplev--;
				break;
				}
				}
				system_data.mcs=lop->pt;
				jit_next();*/
				break;
			}

		case 0x06:								// continue
			printf("\tcontinue\n");
			{
				/*
				LOOPDAT *lop;
				unsigned short *label;
				label = code_getlb();
				lop=GETLOP(system_data.hspctx->looplev);
				jit_next();
				p2=lop->cnt + 1;
				p1 = code_getdi( p2 );
				lop->cnt = p1 - 1;
				system_data.mcs=label;
				system_data.val=0x05;system_data.type=TYPE_PROGCMD;system_data.exflg=0;	// set 'loop' code
				*/
				break;
			}

		case 0x07:								// wait
			printf("\twait\n");
			/*		system_data.hspctx->waitcount = code_getdi( 100 );
			system_data.hspctx->runmode = RUNMODE_WAIT;*/
			break;

		case 0x08:								// await
			printf("\tawait\n");
			parseCommand();
			/*		p1=code_getdi( 0 );
			//p2=code_getdi( -1 );
			system_data.hspctx->waitcount = p1;
			system_data.hspctx->waittick = -1;
			//if ( p2 > 0 ) system_data.hspctx->waitbase = p2;
			system_data.hspctx->runmode = RUNMODE_AWAIT;*/
			break;

		case 0x09:								// dim
		case 0x0a:								// sdim
		case 0x0d:								// dimtype
			{
				printf("\tdim\n");
				parseCommand();
				/*		HspVarProc *proc;
				PVal *pval;
				int fl;
				pval = code_getpval();
				fl = TYPE_INUM;
				if ( cmd == 0x0d ) {
				fl = code_geti();
				proc = HspVarCoreGetProc( fl );
				if ( proc->flag == 0 ) throw HSPERR_ILLEGAL_FUNCTION;
				}
				p1 = code_getdi( 0 );
				p2 = code_getdi( 0 );
				p3 = code_getdi( 0 );
				p4 = code_getdi( 0 );
				if ( cmd == 0x0a ) {
				p5 = code_getdi( 0 );
				HspVarCoreDimFlex( pval, TYPE_STRING, p1, p2, p3, p4, p5 );
				//HspVarCoreAllocBlock( pval, HspVarCorePtrAPTR( pval, 0 ), p1 );
				break;
				}
				HspVarCoreDim( pval, fl, p1, p2, p3, p4 );
				*/
				break;
			}

		case 0x0b:								// foreach
			printf("\tforeach\n");
			{
				/*		LOOPDAT *lop;
				unsigned short *label;
				if (system_data.hspctx->looplev>=(HSP3_REPEAT_MAX-1)) throw HSPERR_TOO_MANY_NEST;
				label = code_getlb();
				jit_next();
				system_data.hspctx->looplev++;
				lop=GETLOP(system_data.hspctx->looplev);
				lop->cnt = 0;
				lop->time = ETRLOOP;
				lop->pt = system_data.mcsbak;*/
				break;
			}
		case 0x0c:								// (hidden)foreach check
			printf("\tforeach_check\n");
			{
				/*		int i;
				PVal *pval;
				LOOPDAT *lop;
				unsigned short *label;
				if (system_data.hspctx->looplev==0) throw HSPERR_LOOP_WITHOUT_REPEAT;
				label = code_getlb();
				jit_next();
				lop=GETLOP(system_data.hspctx->looplev);

				pval = code_getpval();
				if ( lop->cnt >= pval->len[1] ) {		// [vI
				system_data.hspctx->looplev--;
				system_data.mcs = label;
				jit_next();
				break;
				}
				if ( pval->support & HSPVAR_SUPPORT_VARUSE ) {
				i = HspVarCoreGetUsing( pval, HspVarCorePtrAPTR( pval, lop->cnt ) );
				if ( i == 0 ) {						// XLbv
				system_data.mcs=label;
				system_data.val=0x05;system_data.type=TYPE_PROGCMD;system_data.exflg=0;	// set 'loop' code
				}
				}*/
				break;
			}
		case 0x0e:								// dup
			printf("\tdup\n");
			{
				/*		PVal *pval_m;
				PVal *pval;
				APTR aptr;
				pval_m = code_getpval();
				aptr = code_getva( &pval );
				HspVarCoreDup( pval_m, pval, aptr );*/
				break;
			}
		case 0x0f:								// dupptr
			printf("\tdupptr\n");
			{
				/*		PVal *pval_m;
				pval_m = code_getpval();
				p1 = code_geti();
				p2 = code_geti();
				p3 = code_getdi( HSPVAR_FLAG_INT );
				if ( p2<=0 ) throw HSPERR_ILLEGAL_FUNCTION;
				if ( HspVarCoreGetProc(p3)->flag == 0 ) throw HSPERR_ILLEGAL_FUNCTION;
				HspVarCoreDupPtr( pval_m, p3, (void *)p1, p2 );*/
				break;
			}

		case 0x10:								// end
			printf("\tend\n");
			/*		system_data.hspctx->endcode = code_getdi(0);
			system_data.hspctx->runmode = RUNMODE_END;*/
			break;
		case 0x1b:								// assert
			printf("\tassert\n");
			/*		p1 = code_getdi( 0 );
			if ( p1 ) break;
			system_data.hspctx->runmode = RUNMODE_ASSERT;*/
			break;
		case 0x11:								// stop
			printf("\tstop\n");
			//parseCommand();
			eatInvocation(false, false);
			builder->CreateRetVoid();
			needBranch = false;
			/*		system_data.hspctx->runmode = RUNMODE_STOP;*/
			break;

		case 0x12:								// newmod
		case 0x13:								// setmod
			printf("\tmod\n");
			{
				/*		char *p;
				PVal *pval;
				APTR aptr;
				FlexValue *fv;
				STRUCTDAT *st;
				STRUCTPRM *prm;
				if ( cmd == 0x12 ) {
				pval = code_getpval();
				aptr = code_newstruct( pval );
				} else {
				aptr = code_getva( &pval );
				}
				st = code_getstruct();
				fv = code_setvs( pval, aptr, NULL, st->size, st->prmindex );
				fv->type = FLEXVAL_TYPE_ALLOC;
				p = sbAlloc( fv->size );
				fv->ptr = (void *)p;
				prm = &system_data.hspctx->mem_minfo[ st->prmindex ];
				if ( prm->mptype != MPTYPE_STRUCTTAG ) throw HSPERR_STRUCT_REQUIRED;
				code_expandstruct( p, st, CODE_EXPANDSTRUCT_OPT_NONE );
				if ( prm->offset != -1 ) {
				system_data.modvar_init.magic = MODVAR_MAGICCODE;
				system_data.modvar_init.subid = prm->subid;
				system_data.modvar_init.pval = pval;
				system_data.modvar_init.aptr = aptr;
				return code_callfunc( prm->offset );
				}*/
				break;
			}
		case 0x14:								// delmod
			printf("\tdelmod\n");
			{
				/*		PVal *pval;
				APTR aptr;
				aptr = code_getva( &pval );
				if ( pval->flag != TYPE_STRUCT ) throw HSPERR_TYPE_MISMATCH;
				code_delstruct( pval, aptr );*/
				break;
			}
			/*
			case 0x15:								// alloc
			{
			PVal *pval;
			pval = code_getpval();
			p1 = code_getdi( 0 );
			if ( p1 <= 64 ) p1 = 64;
			HspVarCoreDim( pval, TYPE_STRING, 1, 0, 0, 0 );
			HspVarCoreAllocBlock( pval, HspVarCorePtrAPTR( pval, 0 ), p1 );
			break;
			}
			*/
		case 0x16:								// mref
			printf("\tmref\n");
			{
				/*		PVal *pval_m;
				pval_m = code_getpval();
				p1 = code_geti();
				cmdfunc_mref( pval_m, p1 );*/
				break;
			}
		case 0x17:								// run
			printf("\trun\n");
			/*		sbStrCopy( &system_data.hspctx->refstr, code_gets() );
			code_stmpstr( code_getds("") );*/
			break;

		case 0x18:								// exgoto
			printf("\texgoto\n");
			{
				/*		PVal *pval;
				APTR aptr;
				int *ival;
				int i;
				unsigned short *label;
				aptr = code_getva( &pval );
				if ( pval->flag != HSPVAR_FLAG_INT ) throw HSPERR_TYPE_MISMATCH;
				ival = (int *)HspVarCorePtrAPTR( pval, aptr );
				p1=code_getdi( 0 );
				p2=code_getdi( 0 );
				label = code_getlb2();
				i = 0;
				if ( p1 >= 0 ) {
				if ( (*ival) >= p2 ) i++;
				} else {
				if ( (*ival) <= p2 ) i++;
				}
				if ( i ) code_setpc( label);*/
				break;
			}

		case 0x19:								// on
			printf("\ton\n");
			{
				/*		unsigned short *label;
				unsigned short *otbak;
				p1=code_getdi( 0 );
				if ( system_data.type != TYPE_PROGCMD ) throw HSPERR_SYNTAX;
				if ( system_data.val >= 0x02 ) throw HSPERR_SYNTAX;	// goto/gosubȊO̓G[
				p2 = 0; p3 = system_data.val; otbak = NULL;
				jit_next();
				while( (system_data.exflg&EXFLG_1)==0 ) {
				label = code_getlb2();
				if ( p1 == p2 ) {
				if ( p3 ) {
				otbak = label;			// on`gosub
				} else {
				code_setpc( label);		// on`goto
				break;
				}
				}
				p2++;
				}
				if ( otbak != NULL ) code_call( otbak );*/
				break;
			}

		case 0x1a:								// mcall
			printf("\tmcall\n");
			{
				/*		PVal *pval;
				HspVarProc *varproc;
				pval = code_getpval();
				varproc = HspVarCoreGetProc( pval->flag );
				varproc->ObjectMethod( pval );*/
				break;
			}
		case 0x1c:								// logmes
			printf("\tlogmes\n");
			/*
			strcpy( system_data.hspctx->stmp, code_gets() );
			system_data.hspctx->runmode = RUNMODE_LOGMES;*/
			break;

		default:
			throw HSPERR_UNSUPPORTED_FUNCTION;
		}
	}

	void parseGoto() {
		Code& code = codes[codeIndex++];
		Code& label = codes[codeIndex++];

		printf("\tgoto %d\n", label.val);
		if (labels.find(label.val) == labels.end())
			throw 0;
		builder->CreateBr(labels[label.val]);
		needBranch = false;
	}

	void parseCommand() {
		parseInvocation(false, false);
	}

	void parseInvocation(bool bracket, bool hasresult) {
		Code& code = codes[codeIndex++];
		printf("invoke %d_%d\n", code.type, code.val);
		code.dump();
		Function *func = findFunc(code);

		bool noeatparam;
		if (bracket && !(codes[codeIndex].type == TYPE_MARK
			&& codes[codeIndex].val == '(')) {
			// p[^VXeϐ
			noeatparam = true;
			bracket = false;
		} else {
			noeatparam = false;
		}

		if (bracket) {
			++codeIndex; // ( ǂݔ΂B
		}

		std::vector<Value*> args;

		parseInvocationParameters(noeatparam, func, args);

		if (bracket) {

			// ')' 炸
			if (!(codes[codeIndex].type == TYPE_MARK
				&& codes[codeIndex].val == ')')) {
				throw ("Ή ) ܂B");
			}

			++codeIndex; // ) ǂݔ΂B
		}

		// ĂяoB
//		mv.visitMethodInsn(Modifier.isStatic(method.getModifiers()) ? INVOKESTATIC : INVOKEVIRTUAL, Type
//				.getInternalName(libraryClass), method.getName(), methodDesc);
/*
		if (func.func) {
			callFuncArg(func.func, args);
		}
*/
		builder->CreateCall(func, args.begin(), args.end());

		if (hasresult) {

			// ֐̂Ƃ͖߂lKvB
/*
			if (method.getReturnType().equals(Void.TYPE)) {

				mv.visitVarInsn(ALOAD, thisIndex);
				mv.visitFieldInsn(GETFIELD, classIName, "c" + literals.indexOf(new Integer(0)), literalDesc);

			} else if (method.getReturnType().equals(Operand.class)) {

				// KvȂ

			} else {

				mv.visitMethodInsn(INVOKESTATIC, literalIName, "fromValue", "("
						+ Type.getDescriptor(method.getReturnType()) + ")" + literalDesc);

			}
			mv.visitInsn(ICONST_0);
*/
			printf("retval\n");
		} else {
			// ߂̂Ƃ͖߂l stat ɑ
/*
			if (method.getReturnType().equals(Integer.TYPE)) {

				mv.visitVarInsn(ALOAD, contextIndex);
				mv.visitFieldInsn(GETFIELD, contextIName, "stat", Type.getDescriptor(IntScalar.class));
				
				mv.visitInsn(SWAP);
				
				mv.visitFieldInsn(PUTFIELD, Type.getInternalName(IntScalar.class), "value", "I");

			} else if (!method.getReturnType().equals(Void.TYPE)) {
				// int ȊO͖
				mv.visitInsn(POP);
			}
			*/
			printf("ret\n");
		}
	}

	void parseInvocationParameters(bool noeatparam, Function* func, std::vector<Value*>& stack) {
		bool firstParam = true;

//		for (int paramIndex = 0; paramIndex < func->paramHasAttr; ++paramIndex) {
		for (Function::const_arg_iterator paramIndex = func->arg_begin(); paramIndex != func->arg_end(); ++paramIndex) {

			//final Class type = method.getParameterTypes()[paramIndex];
			//int type = func.types[paramIndex];
			const Type* type = paramIndex->getType();
			bool omitted;
			Code& code = codes[codeIndex];
			if (!noeatparam && codeIndex < codes.size() && !(code.newline())
				&& !(code.type == TYPE_MARK && code.val == ')')) {
					if (firstParam && code.comma()) {
						omitted = true;
					} else if (code.type == TYPE_MARK && code.val == '?') {
						omitted = true;
						++codeIndex;
					} else {
						omitted = false;
					}
				} else {
					omitted = true;
				}

				firstParam = false;

				if (!omitted) {
					Value* param = parseExpression();
					if (param->getType() == type) {
					} else if(param->getType() == typePPVal && type == Type::Int32Ty) {
						param = pvalToInt(param);
					} else {
						printf("type missmatch\n");
						throw 0;
					}
					stack.push_back(param);
/*
					if (type.equals(Operand.class)) {

						++paramIndex; //  int ͓ǂݔ΂

						// ͕K int
						if (!method.getParameterTypes()[paramIndex].equals(Integer.TYPE)) {
							throw new RuntimeException();
						}

					} else if (type.equals(Integer.TYPE)) {

						mv.visitMethodInsn(INVOKEVIRTUAL, opeIName, "toInt", "(I)I");

					} else if (type.equals(Double.TYPE)) {

						mv.visitMethodInsn(INVOKEVIRTUAL, opeIName, "toDouble", "(I)D");

					} else if (type.equals(ByteString.class)) {

						mv.visitMethodInsn(INVOKEVIRTUAL, opeIName, "toByteString", "(I)" + Type.getDescriptor(type));

					} else if (type.equals(String.class)) {

						mv.visitMethodInsn(INVOKEVIRTUAL, opeIName, "toString", "(I)"
								+ Type.getDescriptor(String.class));

					} else {
						throw new UnsupportedOperationException("gCü^ " + type + " ̓T|[gĂ܂B");
					}
*/
				} else {
/*					if (type.equals(Operand.class)) {

						mv.visitInsn(ACONST_NULL);
						mv.visitInsn(ICONST_0);

						++paramIndex; //  int ͓ǂݔ΂

						// ͕K int
						if (!method.getParameterTypes()[paramIndex].equals(Integer.TYPE)) {
							throw new RuntimeException(
									"gCü Operand 󂯎Ƃ͂Ȃ炸̎̈ŔzCfbNX󂯎Ȃ΂܂B");
						}

					} else if (type.equals(Integer.TYPE)) {

						mv.visitInsn(ICONST_0);

					} else if (type.equals(Double.TYPE)) {

						mv.visitInsn(DCONST_0);

					} else {

						mv.visitInsn(ACONST_NULL);

					}
*/
/*
					switch (type) {
					case TYPE_INUM:
						stack.push_back(Value(Value::VT_IIMM, 0));
						break;
					case TYPE_DNUM:
						stack.push_back(Value(Value::VT_DIMM, 0.0));
						break;
					case TYPE_STRING:
						stack.push_back(Value(Value::VT_SIMM, ""));
						break;
					default:
						stack.push_back(Value(Value::VT_IMM, NULL));
						break;
					}
*/
				}
/*			if (type.equals(Context.class)) {

				mv.visitVarInsn(ALOAD, contextIndex);

			} else if (type.equals(JumpStatement.class)) {

				if (!noeatparam && codeIndex < ax.codes.length && !(ax.codes[codeIndex].newLine)
						&& !(ax.codes[codeIndex].type == Code.Type.Mark && ax.codes[codeIndex].value == ')')
						&& (ax.codes[codeIndex].type == Code.Type.ProgCmd)) {

					mv.visitFieldInsn(GETSTATIC, Type.getInternalName(JumpStatement.class),
							ax.codes[codeIndex].value == 0 ? "Goto" : "Gosub", Type.getDescriptor(JumpStatement.class));

					++codeIndex;
				} else {
					mv.visitInsn(ACONST_NULL);
				}

			} else {

				boolean omitted;

				final Code code = ax.codes[codeIndex];

				if (!noeatparam && codeIndex < ax.codes.length && !(code.newLine)
						&& !(code.type == Code.Type.Mark && code.value == ')')) {

					if (firstParam && code.comma) {
						omitted = true;
					} else if (code.type == Code.Type.Mark && code.value == '?') {
						omitted = true;
						++codeIndex;
					} else {
						omitted = false;
					}
				} else {
					omitted = true;
				}

				firstParam = false;

				if (!omitted) {
					compileExpression(mv);

					if (type.equals(Operand.class)) {

						++paramIndex; //  int ͓ǂݔ΂

						// ͕K int
						if (!method.getParameterTypes()[paramIndex].equals(Integer.TYPE)) {
							throw new RuntimeException();
						}

					} else if (type.equals(Integer.TYPE)) {

						mv.visitMethodInsn(INVOKEVIRTUAL, opeIName, "toInt", "(I)I");

					} else if (type.equals(Double.TYPE)) {

						mv.visitMethodInsn(INVOKEVIRTUAL, opeIName, "toDouble", "(I)D");

					} else if (type.equals(ByteString.class)) {

						mv.visitMethodInsn(INVOKEVIRTUAL, opeIName, "toByteString", "(I)" + Type.getDescriptor(type));

					} else if (type.equals(String.class)) {

						mv.visitMethodInsn(INVOKEVIRTUAL, opeIName, "toString", "(I)"
								+ Type.getDescriptor(String.class));

					} else {
						throw new UnsupportedOperationException("gCü^ " + type + " ̓T|[gĂ܂B");
					}

				} else {

					if (type.equals(Operand.class)) {

						mv.visitInsn(ACONST_NULL);
						mv.visitInsn(ICONST_0);

						++paramIndex; //  int ͓ǂݔ΂

						// ͕K int
						if (!method.getParameterTypes()[paramIndex].equals(Integer.TYPE)) {
							throw new RuntimeException(
									"gCü Operand 󂯎Ƃ͂Ȃ炸̎̈ŔzCfbNX󂯎Ȃ΂܂B");
						}

					} else if (type.equals(Integer.TYPE)) {

						mv.visitInsn(ICONST_0);

					} else if (type.equals(Double.TYPE)) {

						mv.visitInsn(DCONST_0);

					} else {

						mv.visitInsn(ACONST_NULL);

					}
				}
			}
			*/
		}
		/*
		bool firstParam = true;

		for (int paramIndex = 0; paramIndex < method.getParameterTypes().length; ++paramIndex) {

			final Class type = method.getParameterTypes()[paramIndex];

			if (type.equals(Context.class)) {

				mv.visitVarInsn(ALOAD, contextIndex);

			} else if (type.equals(JumpStatement.class)) {

				if (!noeatparam && codeIndex < ax.codes.length && !(ax.codes[codeIndex].newLine)
						&& !(ax.codes[codeIndex].type == Code.Type.Mark && ax.codes[codeIndex].value == ')')
						&& (ax.codes[codeIndex].type == Code.Type.ProgCmd)) {

					mv.visitFieldInsn(GETSTATIC, Type.getInternalName(JumpStatement.class),
							ax.codes[codeIndex].value == 0 ? "Goto" : "Gosub", Type.getDescriptor(JumpStatement.class));

					++codeIndex;
				} else {
					mv.visitInsn(ACONST_NULL);
				}

			} else {

				boolean omitted;

				final Code code = ax.codes[codeIndex];

				if (!noeatparam && codeIndex < ax.codes.length && !(code.newLine)
						&& !(code.type == Code.Type.Mark && code.value == ')')) {

					if (firstParam && code.comma) {
						omitted = true;
					} else if (code.type == Code.Type.Mark && code.value == '?') {
						omitted = true;
						++codeIndex;
					} else {
						omitted = false;
					}
				} else {
					omitted = true;
				}

				firstParam = false;

				if (!omitted) {
					compileExpression(mv);

					if (type.equals(Operand.class)) {

						++paramIndex; //  int ͓ǂݔ΂

						// ͕K int
						if (!method.getParameterTypes()[paramIndex].equals(Integer.TYPE)) {
							throw new RuntimeException();
						}

					} else if (type.equals(Integer.TYPE)) {

						mv.visitMethodInsn(INVOKEVIRTUAL, opeIName, "toInt", "(I)I");

					} else if (type.equals(Double.TYPE)) {

						mv.visitMethodInsn(INVOKEVIRTUAL, opeIName, "toDouble", "(I)D");

					} else if (type.equals(ByteString.class)) {

						mv.visitMethodInsn(INVOKEVIRTUAL, opeIName, "toByteString", "(I)" + Type.getDescriptor(type));

					} else if (type.equals(String.class)) {

						mv.visitMethodInsn(INVOKEVIRTUAL, opeIName, "toString", "(I)"
								+ Type.getDescriptor(String.class));

					} else {
						throw new UnsupportedOperationException("gCü^ " + type + " ̓T|[gĂ܂B");
					}

				} else {

					if (type.equals(Operand.class)) {

						mv.visitInsn(ACONST_NULL);
						mv.visitInsn(ICONST_0);

						++paramIndex; //  int ͓ǂݔ΂

						// ͕K int
						if (!method.getParameterTypes()[paramIndex].equals(Integer.TYPE)) {
							throw new RuntimeException(
									"gCü Operand 󂯎Ƃ͂Ȃ炸̎̈ŔzCfbNX󂯎Ȃ΂܂B");
						}

					} else if (type.equals(Integer.TYPE)) {

						mv.visitInsn(ICONST_0);

					} else if (type.equals(Double.TYPE)) {

						mv.visitInsn(DCONST_0);

					} else {

						mv.visitInsn(ACONST_NULL);

					}
				}
			}

		}
*/
		// Ȃ͓ǂݔ΂B
		while (!noeatparam && codeIndex < codes.size() && !(codes[codeIndex].newline())
			&& !(codes[codeIndex].type == TYPE_MARK && codes[codeIndex].val == ')')) {
				parseExpression();
		}
	}

	void eatInvocation(bool bracket, bool hasresult) {
		Code& code = codes[codeIndex++];

		bool noeatparam;
		if (bracket && !(codes[codeIndex].type == TYPE_MARK
			&& codes[codeIndex].val == '(')) {
			// p[^VXeϐ
			noeatparam = true;
			bracket = false;
		} else {
			noeatparam = false;
		}

		if (bracket) {
			++codeIndex; // ( ǂݔ΂B
		}

		// ǂݔ΂B
		while (codeIndex < codes.size() && !(codes[codeIndex].newline())
			&& !(codes[codeIndex].type == TYPE_MARK && codes[codeIndex].val == ')')) {
				parseExpression();
		}
	}

	void parseToken() {
		printf("token type=%d\n", codes[codeIndex].type);
		codes[codeIndex].dump();
		switch(codes[codeIndex].type) {
		case TYPE_MARK:
			parseOperator();
			break;
		case TYPE_VAR:
			parseVar();
			break;
		case TYPE_INUM:
			{
				Code& code = codes[codeIndex++];
				printf("pushi %d\n", code.val);
				Value *v = ConstantInt::get(Type::Int32Ty, code.val);
				varStack.push(v);
				break;
			}
		case TYPE_STRING:
			{
				printf("string\n");
				throw 0;
/*
				Code& code = codes[codeIndex++];
				printf("pushs %s\n", ctx->mem_mds + code.val);
				//stack->push_back(literals[code.offset]);
				varStack.push(lastVar++);
				AbstCode* ac = AbstCode::create(AbstCode::OP_load,
					Value(Value::VT_SREG, varStack.top()),
					Value(Value::VT_SIMM, ctx->mem_mds + code.val));
				abstCodes.push_back(ac);
*/
				break;
			}
			break;
		case TYPE_DNUM:
			{
				printf("double\n");
				throw 0;
/*
				Code& code = codes[codeIndex++];
				printf("pushs %f\n", *(double*)(ctx->mem_mds + code.val));
//				stack->push_back(literals[code.offset]);
				varStack.push(lastVar++);
				AbstCode* ac = AbstCode::create(AbstCode::OP_load,
					Value(Value::VT_DREG, varStack.top()),
					Value(Value::VT_DIMM, *(double*)(ctx->mem_mds + code.val)));
				abstCodes.push_back(ac);
				break;
*/
			}
			break;
		case TYPE_STRUCT:
			printf("struct\n");
			throw 0;
			break;
		case TYPE_LABEL:
			printf("label\n");
			throw 0;
			break;
		case TYPE_SYSVAR:
			printf("sysvar\n");
			throw 0;
			break;
		case TYPE_EXTSYSVAR:
		case TYPE_MODCMD:
		case TYPE_INTFUNC:
		case TYPE_PROGCMD:
		case TYPE_DLLFUNC:
			printf("etc token\n");
			throw 0;
			break;
		default:
			codes[codeIndex].dump();
			throw 0;
			break;
		}
	}


	void parseVar() {
		Code& code = codes[codeIndex++];

		printf("pushv v_%d\n", code.val);
		PVal *argpv;
		//argpv = &ctx->mem_var[code.val];
		Value *pv = builder->CreateGEP(varMemVar, ConstantInt::get(APInt(32, code.val)));
		Value *v = builder->CreateLoad(pv);
		v = parseArrayIndex(v);

		varStack.push(v);
	}

	void parseParam() {
		Code& code = codes[codeIndex++];
		throw 0;
#if 0
		printf("pushv p_%d\n", code.val);
		Value v = Value(Value::VT_PRM, code.val);

		parseArrayIndex(v);

		varStack.push(lastVar++);
		AbstCode* ac = AbstCode::create(AbstCode::OP_load,
			Value(Value::VT_REG, varStack.top()),
			v);
		abstCodes.push_back(ac);
#endif
	}

	Value* parseArrayIndex(Value* v) {
		int paramCount = 0;
		//assert(v.type & (Value::VT_VAR | Value::VT_PRM));

/*
		for (int i = 0; i < 5; i++)
			v.index[i] = new Value(Value::VT_IIMM, 0);
*/

		if (codeIndex < codes.size() && codes[codeIndex].type == TYPE_MARK && codes[codeIndex].val == '(') {
			printf("array\n");
			throw 0;
/*
			++codeIndex;
			int index = codeIndex;
			
			bool moreThan2Dim = (codeIndex < codes.size() &&
				!(codes[codeIndex].type == TYPE_MARK && codes[codeIndex].val == ')'));

			codeIndex = index;

			if (!moreThan2Dim) {
				delete v.index[0];
				v.index[0] = new Value(parseExpression());
				printf("to_int\n", 0);
			} else {
				// zvfANZX

				do {
					delete v.index[paramCount];
					v.index[paramCount] = new Value(parseExpression());
					++paramCount;

					printf("to_int\n", 0);

				} while (codeIndex < codes.size()
					&& !(codes[codeIndex].type == TYPE_MARK && codes[codeIndex].val == ')'));

				//mv.visitMethodInsn(INVOKEVIRTUAL, opeIName, "getIndex", "(" + "IIII".substring(0, paramCount) + ")I");
				//printf("getIndex %d\n", paramCount);
			}

			++codeIndex;
*/
		} else {
			printf("index pushi %d\n", 0);
			return v;
		}
	}

	void parseOperator() {
		Code& code = codes[codeIndex++];

		printf("func_%d%\n", code.val);

		Value* rhs = varStack.top();
		varStack.pop();
		if (rhs->getType() == typePPVal) {
			rhs = pvalToInt(rhs);
		}
		Value* lhs = varStack.top();
		varStack.pop();
		if (lhs->getType() == typePPVal) {
			lhs = pvalToInt(lhs);
		}
		switch(code.val){
		case CALCCODE_ADD:
			//proc->AddI( pval, ptr );
			varStack.push(builder->CreateAdd(lhs, rhs));
			break;
		case CALCCODE_SUB:
			//proc->SubI( pval, ptr );
			varStack.push(builder->CreateSub(lhs, rhs));
			break;
		case CALCCODE_MUL:
			//proc->MulI( pval, ptr );
			varStack.push(builder->CreateMul(lhs, rhs));
			break;
		case CALCCODE_DIV:
			//proc->DivI( pval, ptr );
			varStack.push(builder->CreateSDiv(lhs, rhs));
			break;
		case CALCCODE_MOD:						// '%'
			//proc->ModI( pval, ptr );
			varStack.push(builder->CreateSRem(lhs, rhs));
			break;

		case CALCCODE_AND:
			//proc->AndI( pval, ptr );
			varStack.push(builder->CreateAnd(lhs, rhs));
			break;
		case CALCCODE_OR:
			//proc->OrI( pval, ptr );
			varStack.push(builder->CreateOr(lhs, rhs));
			break;
		case CALCCODE_XOR:
			//proc->XorI( pval, ptr );
			varStack.push(builder->CreateXor(lhs, rhs));
			break;

		case CALCCODE_EQ:
			//proc->EqI( pval, ptr );
			varStack.push(builder->CreateICmp(ICmpInst::ICMP_EQ, lhs, rhs));
			break;
		case CALCCODE_NE:
			//proc->NeI( pval, ptr );
			varStack.push(builder->CreateICmp(ICmpInst::ICMP_NE, lhs, rhs));
			break;
		case CALCCODE_GT:
			//proc->GtI( pval, ptr );
			varStack.push(builder->CreateICmp(ICmpInst::ICMP_SGT, lhs, rhs));
			break;
		case CALCCODE_LT:
			//proc->LtI( pval, ptr );
			varStack.push(builder->CreateICmp(ICmpInst::ICMP_SLT, lhs, rhs));
			break;
		case CALCCODE_GTEQ:						// '>='
			//proc->GtEqI( pval, ptr );
			varStack.push(builder->CreateICmp(ICmpInst::ICMP_SGE, lhs, rhs));
			break;
		case CALCCODE_LTEQ:						// '<='
			//proc->LtEqI( pval, ptr );
			varStack.push(builder->CreateICmp(ICmpInst::ICMP_SLE, lhs, rhs));
			break;

		case CALCCODE_RR:						// '>>'
			//proc->RrI( pval, ptr );
			varStack.push(builder->CreateLShr(lhs, rhs));
			printf("call \n");
			break;
		case CALCCODE_LR:						// '<<'
			//proc->LrI( pval, ptr );
			varStack.push(builder->CreateShl(lhs, rhs));
			break;

		case '(':
			code.dump();
			throw HSPERR_INVALID_ARRAY;
		default:
			code.dump();
			throw HSPVAR_ERROR_INVALID;
		}
	}


	void parseCompareCommand() {
		Code& code = codes[codeIndex];
		switch (code.val) {
		case 0:
			printf("if\n");
			parseIf();
			break;
		case 1:
			printf("else\n");
			parseElse();
			break;
		default:
			throw 0;
		}
	}

	void parseIf() {
		Code& code = codes[codeIndex++];
		Code& to = codes[codeIndex++];

		if (to.val % 2) {
			printf("parse error if %d\n", code.val);
			throw 0;
		}

		int n = to.val / 2 + codes[codeIndex].offset;

		Value* cond = parseExpression();

		printf("if_eq %d\n", n);
		if (cond->getType() == typePPVal) {
			cond = pvalToInt(cond);
		} else if (cond->getType()->isInteger()) {
			cond = builder->CreateIntCast(cond, Type::Int1Ty, true);
		} else {
			printf("unsupported condition\n");
			cond->getType()->dump();
			throw 0;
		}
		Value* test = builder->CreateICmpEQ(cond, ConstantInt::get(Type::Int1Ty, 1));
		if (nextBlock != NULL) {
			printf("parse if error\n");
			throw 0;
		}


		BasicBlock *bb = getLineBlock(n);
#if 0
		if (lines.find(n) == lines.end()) {
			bb = BasicBlock::Create("", func);
			lines[n] = bb;
		} else {
			bb = lines[n];
		}
#endif
		nextBlock = BasicBlock::Create("", func);
		builder->CreateCondBr(test, nextBlock, bb);
		needBranch = false;
	}

	void parseElse() {
		Code& code = codes[codeIndex++];
		Code& to = codes[codeIndex++];

		parseExpression();

		printf("else_goto %d\n", to.val + to.offset);
	}
	void parseSysVar() {
		Code& code = codes[codeIndex++];
		printf("pushv sys_%d\n", code.val);
	}

	Function* findFunc(Code& code) {
		//final Class clazz = getClassFor(ax, code);
		//std::string name;
		printf("find func %d %d\n", code.type, code.val);

		switch (code.type) {
		case TYPE_INTCMD://.Code.Type.IntCmd:
			throw 0;
			//name = basicCommands[code.value];
			break;
		case TYPE_EXTCMD://.Code.Type.ExtCmd:
			{
				switch (code.val) {
				case 0x0f:								// mes,print
					return progExtCmdMes;
				default:
					throw 0;
				}
			}
			//name = guiCommands[code.value];
			break;
		case TYPE_INTFUNC://.Code.Type.IntFunc:
			throw 0;
/*
			switch (code.value & 0x180) {
			case 0x000:
				name = basicFunctions[0][code.value & 0x7F];
				break;
			case 0x100:
				name = basicFunctions[1][code.value & 0x7F];
				break;
			case 0x180:
				name = basicFunctions[2][code.value & 0x7F];
				break;
			default:
				throw new UnsupportedOperationException("֐ " + code.value
						+ " ̓T|[gĂ܂B");
			}
*/
			break;
		case TYPE_EXTSYSVAR://.Code.Type.ExtSysVar:
			throw 0;
/*
			switch (code.value & 0x100) {
			case 0x000:
				name = guiFunctions[0][code.value & 0xFF];
				break;
			case 0x100:
				name = guiFunctions[1][code.value & 0xFF];
				break;
			default:
				throw new UnsupportedOperationException("g GUI ֐ "
						+ code.value + " ̓T|[gĂ܂B");
			}
*/
			break;
		case TYPE_PROGCMD://ByteCode.Code.Type.ProgCmd:
			{
				switch (code.val) {
				case 17:
					return progCmdStop;
				default:
					throw 0;
				}
			}
			//name = programCommands[code.value];
			break;
		case TYPE_MODCMD://ByteCode.Code.Type.ModCmd:
			//name = "call";
			throw 0;
			break;
		case TYPE_DLLFUNC://.Code.Type.DllFunc:
			throw 0;
/*
 {
			final ByteCode.Function func = ax.functions[code.value];

			final String rawName = new ByteString(ax.datas, func.nameidx, false)
			.toString();
			if (rawName.indexOf('@') >= 0) {
				if (rawName.charAt(0) == '_') {
					name = rawName.substring(1, rawName.indexOf('@'));
				} else {
					name = rawName.substring(0, rawName.indexOf('@'));
				}
			} else {
				name = rawName;
			}
		}
*/
		break;
		default:
			printf("߃^Cv %d ̓\bhƊ֘At܂B", code.type);
			throw 0;
		}
		//return NULL;
	}

	Value* pvalToPInt(Value* pval) {
		Value *idx[2];
		idx[0] = ConstantInt::get(APInt(32, 0));
		idx[1] = ConstantInt::get(APInt(32, 4));
		Value* pPvalPt = builder->CreateGEP(pval, &(idx[0]), &(idx[2]));
/*
		Value* pvalPt = builder->CreateBitCast(pPvalPt, PointerType::getUnqual(PointerType::getUnqual(Type::Int32Ty)));
		Value* ptr = builder->CreateLoad(pvalPt);
*/
		Value* pt = builder->CreateLoad(pPvalPt);
		Value* ip = builder->CreateBitCast(pt, PointerType::getUnqual(Type::Int32Ty));
		return ip;
	}

	Value* pvalToInt(Value* pval) {
		Value* ptr = pvalToPInt(pval);
		Value* val = builder->CreateLoad(ptr);
		return val;
	}
	Module *module;
	IRBuilder *builder;

	size_t codeIndex;
	HSPCTX* ctx;
	Codes codes;
	int lastLabel;
	std::stack<std::string> loopLabels;
//	std::vector<Value*> abstCodes;
	std::stack<Value*> varStack;
	int lastVar;

	Function *progCmdStop, *progExtCmdMes;
};


extern HSPCTX* ctx;
static Parser* parser;
static Module *llvmModule;
static std::vector<std::pair<Function*, int> > compiledFunctions;
static const Function* BAD_FUNC = (Function*)-1;

int jit_execcmd( void )
{
	std::string datalayout = "e-p:32:32:32-i1:8:8-i8:8:8-i16:16:16-i32:32:32-i64:32:64-f32:32:32-f64:32:64-v64:64:64-v128:128:128-a0:0:64-s0:0:64-f80:32:32";
	llvmModule = new Module("hsp");
	llvmModule->setDataLayout(datalayout);
	parser = new Parser(ctx, llvmModule);

	Function* hspMain = parser->parse();//CreateFibFunction(llvmModule)

	if (hspMain == NULL)
		return 1;

	// Now we going to create JIT
	ExistingModuleProvider *MP = new ExistingModuleProvider(llvmModule);
	ExecutionEngine *EE = ExecutionEngine::create(MP, false);

	EE->InstallLazyFunctionCreator(hspLazyFunctionCreator);

	if (true) {
		std::ostringstream tmp;
		tmp << *llvmModule;
		printf("%s\n", tmp.str().c_str());
	}
	printf("verifying...\n");
	if (verifyModule(*llvmModule)) {
		printf(" Error constructing function!\n");
		return 1;
	}

	printf("optimizing...\n");
    ExistingModuleProvider OurModuleProvider(llvmModule);
    FunctionPassManager FPM(MP);
      
    // Set up the optimizer pipeline.  Start with registering info about how the
    // target lays out data structures.
    FPM.add(new TargetData(*EE->getTargetData()));
    // Do simple "peephole" optimizations and bit-twiddling optzns.
    FPM.add(createInstructionCombiningPass());
    // Reassociate expressions.
    FPM.add(createReassociatePass());
    // Eliminate Common SubExpressions.
    FPM.add(createGVNPass());
    // Simplify the control flow graph (deleting unreachable blocks, etc).
    FPM.add(createCFGSimplificationPass());

	// Optimize
	FPM.run(*hspMain);

	// Dump optimized code
	if (true) {
		std::ostringstream tmp;
		tmp << *llvmModule;
		printf("%s\n", tmp.str().c_str());
	}

	printf("OK\n");
	printf("We just constructed this LLVM module:\n\n---------\n");

	std::ostringstream tmp;
	tmp << *llvmModule;
	printf("%s\n", tmp.str().c_str());
	//std::cerr << "---------\nstarting fibonacci(" << n << ") with JIT...\n";

	printf("mem_var %d %d\n", (int)ctx->mem_var, (int)&ctx->mem_var);
	printf("v[0] @ %d, v[1] @ %d\n", (int)ctx->mem_var[0].pt, (int)&ctx->mem_var[0].pt);
#if 0
	// Call the Fibonacci function with argument n:
	std::vector<GenericValue> Args(0);
	//Args[0].IntVal = APInt(32, 10);
	GenericValue GV = EE->runFunction(hspMain, Args);
	DWORD end  = timeGetTime();
	printf("%f ms\n", (end - start) / 1000.0);
#else
	// JIT the function, returning a function pointer.
	printf("Compiling \n");
	void *FPtr = EE->getPointerToFunction(hspMain);

	printf("Evaluating\n");

	DWORD start = timeGetTime();
     
	void (*FP)() = (void (*)())FPtr;
	FP();
	DWORD end  = timeGetTime();
	printf("%f sec\n", (end - start) / 1000.0);
#endif
	printf("v[0] = %d\n", *(int*)ctx->mem_var[0].pt);

	printf("ok.\n");
	//delete parser;
	//delete llvmModule;
	return 0;
}


int jit_execcmd2( void )
{
	//		IȎssȂ(ENDSESSIONp)
	//
	while(1) {
		if ( GetTypeInfoPtr( s_type )->cmdfunc( s_val ) ) {	// ^CvƂ̊֐U蕪
			break;
		}
	}
	return s_hspctx->runmode;
}

extern "C" {
	void hspExtMes(int n) {
		printf( "%d\n", n );
	}
}